function _array_like_to_array(arr, len) {
    if (len == null || len > arr.length) len = arr.length;
    for(var i = 0, arr2 = new Array(len); i < len; i++)arr2[i] = arr[i];
    return arr2;
}
function _array_with_holes(arr) {
    if (Array.isArray(arr)) return arr;
}
function _iterable_to_array_limit(arr, i) {
    var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"];
    if (_i == null) return;
    var _arr = [];
    var _n = true;
    var _d = false;
    var _s, _e;
    try {
        for(_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true){
            _arr.push(_s.value);
            if (i && _arr.length === i) break;
        }
    } catch (err) {
        _d = true;
        _e = err;
    } finally{
        try {
            if (!_n && _i["return"] != null) _i["return"]();
        } finally{
            if (_d) throw _e;
        }
    }
    return _arr;
}
function _non_iterable_rest() {
    throw new TypeError("Invalid attempt to destructure non-iterable instance.\\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method.");
}
function _sliced_to_array(arr, i) {
    return _array_with_holes(arr) || _iterable_to_array_limit(arr, i) || _unsupported_iterable_to_array(arr, i) || _non_iterable_rest();
}
function _unsupported_iterable_to_array(o, minLen) {
    if (!o) return;
    if (typeof o === "string") return _array_like_to_array(o, minLen);
    var n = Object.prototype.toString.call(o).slice(8, -1);
    if (n === "Object" && o.constructor) n = o.constructor.name;
    if (n === "Map" || n === "Set") return Array.from(n);
    if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _array_like_to_array(o, minLen);
}
import { groups, max, min, sum } from "d3-array";
/**
    @module barBuffer
    Adds a buffer to either side of the non-discrete axis.


    @param buffer @private
*/ export default function(param) {
    var _this = this;
    var data = param.data, x = param.x, y = param.y, x2 = param.x2, y2 = param.y2, _param_buffer = param.buffer, buffer = _param_buffer === void 0 ? 10 : _param_buffer;
    var xKey = x2 ? "x2" : "x";
    var yKey = y2 ? "y2" : "y";
    var oppScale = this._discrete === "x" ? y : x;
    var oppDomain = oppScale.domain().slice();
    var isDiscreteX = this._discrete === "x";
    if (isDiscreteX) oppDomain.reverse();
    var negVals, posVals;
    if (this._stacked) {
        var groupedData = groups(data, function(d) {
            return "".concat(d[_this._discrete], "_").concat(d.group);
        }).map(function(param) {
            var _param = _sliced_to_array(param, 2), values = _param[1];
            return values.map(function(x) {
                return x[isDiscreteX ? yKey : xKey];
            });
        });
        posVals = groupedData.map(function(arr) {
            return sum(arr.filter(function(d) {
                return d > 0;
            }));
        });
        negVals = groupedData.map(function(arr) {
            return sum(arr.filter(function(d) {
                return d < 0;
            }));
        });
    } else {
        var allValues = data.map(function(d) {
            return d[isDiscreteX ? yKey : xKey];
        });
        posVals = allValues.filter(function(d) {
            return d > 0;
        });
        negVals = allValues.filter(function(d) {
            return d < 0;
        });
    }
    var bMax = oppScale(max(posVals));
    if (isDiscreteX ? bMax < oppScale(0) : bMax > oppScale(0)) bMax += isDiscreteX ? -buffer : buffer;
    bMax = oppScale.invert(bMax);
    var bMin = oppScale(min(negVals));
    if (isDiscreteX ? bMin > oppScale(0) : bMin < oppScale(0)) bMin += isDiscreteX ? buffer : -buffer;
    bMin = oppScale.invert(bMin);
    if (bMax > oppDomain[1]) oppDomain[1] = bMax;
    if (bMin < oppDomain[0]) oppDomain[0] = bMin;
    if (isDiscreteX) oppDomain.reverse();
    oppScale.domain(oppDomain);
    return [
        x,
        y
    ];
}
